"""
   Python SDK for OpenFGA

   API version: 1.x
   Website: https://openfga.dev
   Documentation: https://openfga.dev/docs
   Support: https://openfga.dev/community
   License: [Apache-2.0](https://github.com/openfga/python-sdk/blob/main/LICENSE)

   NOTE: This file was auto generated by OpenAPI Generator (https://openapi-generator.tech). DO NOT EDIT.
"""

try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint

from openfga_sdk.configuration import Configuration


class Leaf:
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "users": "Users",
        "computed": "Computed",
        "tuple_to_userset": "UsersetTreeTupleToUserset",
    }

    attribute_map = {
        "users": "users",
        "computed": "computed",
        "tuple_to_userset": "tupleToUserset",
    }

    def __init__(
        self,
        users=None,
        computed=None,
        tuple_to_userset=None,
        local_vars_configuration=None,
    ):
        """Leaf - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._users = None
        self._computed = None
        self._tuple_to_userset = None
        self.discriminator = None

        if users is not None:
            self.users = users
        if computed is not None:
            self.computed = computed
        if tuple_to_userset is not None:
            self.tuple_to_userset = tuple_to_userset

    @property
    def users(self):
        """Gets the users of this Leaf.


        :return: The users of this Leaf.
        :rtype: Users
        """
        return self._users

    @users.setter
    def users(self, users):
        """Sets the users of this Leaf.


        :param users: The users of this Leaf.
        :type users: Users
        """

        self._users = users

    @property
    def computed(self):
        """Gets the computed of this Leaf.


        :return: The computed of this Leaf.
        :rtype: Computed
        """
        return self._computed

    @computed.setter
    def computed(self, computed):
        """Sets the computed of this Leaf.


        :param computed: The computed of this Leaf.
        :type computed: Computed
        """

        self._computed = computed

    @property
    def tuple_to_userset(self):
        """Gets the tuple_to_userset of this Leaf.


        :return: The tuple_to_userset of this Leaf.
        :rtype: UsersetTreeTupleToUserset
        """
        return self._tuple_to_userset

    @tuple_to_userset.setter
    def tuple_to_userset(self, tuple_to_userset):
        """Sets the tuple_to_userset of this Leaf.


        :param tuple_to_userset: The tuple_to_userset of this Leaf.
        :type tuple_to_userset: UsersetTreeTupleToUserset
        """

        self._tuple_to_userset = tuple_to_userset

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(lambda x: convert(x), value))
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(lambda item: (item[0], convert(item[1])), value.items())
                )
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Leaf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Leaf):
            return True

        return self.to_dict() != other.to_dict()
